{ inputs }: rec {
  users = {
    hulk = {
      username = "sadorowo";
      fullname = "Franek";
      homeDirectory = "/home/${users.hulk.username}";
      preferredShell = pkgs: pkgs.fish;
      isRoot = false;
    };
  };

  nixpkgs = system: import inputs.nixpkgs {
    inherit system;
    overlays = [ (import ./overlay.nix inputs) ];
    config = {
      nvidia.acceptLicense = true;
      permittedInsecurePackages = [
        "fluffychat-linux-1.22.1"
        "olm-3.2.16"
      ];
      
      allowUnfreePredicate = pkg: builtins.elem (inputs.nixpkgs.lib.getName pkg) [
        "davinci-resolve"
        "anydesk"
        "nvidia-settings"
        "nvidia-x11"
        "nordvpn"
        "hplip"
      ];
    };
  };

  hosts = {
    hulk = {
      nvidiaBusId = "PCI:2:0:0";
      intelBusId  = "PCI:0:2:0";
    };
  };

  homes = {
    sadorowo = ./profiles/sadorowo;
  };
}
